#include <stdio.h>


/* score element class */

#define SCORE_CREF   1
#define SCORE_KEY    2
#define SCORE_RITHM  3
#define SCORE_NOTE   4
#define SCORE_REST   5
#define SCORE_SIG    6    /* key signiture */
#define SCORE_BAR    7    /* bar section mark */


/* rithm */

#define BINARIA      2    /*  2/2  */
#define TERNARIA     3	  /*  3/4  */
#define QUATERNARIA  4	  /*  4/4  */
#define CROME        6	  /*  6/8  */
#define SEMICROME    9	  /*  9/16 */
#define TWOFOURTH    24   /*  2/4  */
#define TWELVEEIGHTH 128  /*  12/8 */


/* keys */

#define C_MAJOR 1
#define D_MAJOR 2
#define E_MAJOR 3
#define F_MAJOR 4
#define G_MAJOR 5
#define A_MAJOR 6
#define B_MAJOR 7
#define A_MINOR 8
#define B_MINOR 9
#define C_MINOR 10
#define D_MINOR 11
#define E_MINOR 12
#define F_MINOR 13
#define G_MINOR 14
#define A_FLAT_MAJOR 15
#define B_FLAT_MAJOR 16
#define C_FLAT_MAJOR 17
#define D_FLAT_MAJOR 18
#define E_FLAT_MAJOR 19
#define B_FLAT_MINOR 20


/* key signituras */

#define SIG_SHARP        1
#define SIG_FLAT         2
#define SIG_NATURAL      3
#define SIG_DOUBLE_SHARP 4
#define SIG_DOUBLE_FLAT  5


int tempo;
int treble_pitch;
int no_of_elements_t;
int bass_pitch;
int no_of_elements_b;

struct Score_element {
    int category;
    int type;
    int pitch;
    int attributes;
    int position;
};

#define SCORE_SIZE 800

struct Score_element score_t[SCORE_SIZE];
int no_of_elements_t;
int score_end_position_t;

struct Score_element score_b[SCORE_SIZE];
int no_of_elements_b;
int score_end_position_b;


/* pitch */

#define PITCH_NONE  0
#define PITCH_C3   36
#define PITCH_D3   38
#define PITCH_E3   40
#define PITCH_F3   41
#define PITCH_G3   43
#define PITCH_A3   45
#define PITCH_B3   47
#define PITCH_C4   48
#define PITCH_D4   50
#define PITCH_E4   52
#define PITCH_F4   53
#define PITCH_G4   55
#define PITCH_A4   57
#define PITCH_B4   59
#define PITCH_C5   60
#define PITCH_D5   62
#define PITCH_E5   64
#define PITCH_F5   65
#define PITCH_G5   67
#define PITCH_A5   69
#define PITCH_B5   71
#define PITCH_C6   72
#define PITCH_D6   74
#define PITCH_E6   76
#define PITCH_F6   77
#define PITCH_G6   79
#define PITCH_A6   81
#define PITCH_B6   83
#define PITCH_C7   84
#define PITCH_D7   86
#define PITCH_E7   88
#define PITCH_F7   89
#define PITCH_G7   91
#define PITCH_A7   93
#define PITCH_B7   95
#define PITCH_C8   96
#define PITCH_D8   98
#define PITCH_E8  100
#define PITCH_F8  101
#define PITCH_G8  103
#define PITCH_A8  105


/* pitch by octave */

#define PITCH_HIGH   1
#define PITCH_MIDDLE 2
#define PITCH_LOW    3


struct Pitch_table {
    int name;
    int value;
};

const struct Pitch_table natural_pitchs[41] = {
    {PITCH_C3, 36}, /*  0 */
    {PITCH_D3, 38},
    {PITCH_E3, 40},
    {PITCH_F3, 41},
    {PITCH_G3, 43},
    {PITCH_A3, 45}, /*  5 */
    {PITCH_B3, 47},
    {PITCH_C4, 48},
    {PITCH_D4, 50},
    {PITCH_E4, 52},
    {PITCH_F4, 53}, /* 10 */
    {PITCH_G4, 55},
    {PITCH_A4, 57},
    {PITCH_B4, 59},
    {PITCH_C5, 60},
    {PITCH_D5, 62}, /* 15 */
    {PITCH_E5, 64},
    {PITCH_F5, 65},
    {PITCH_G5, 67},
    {PITCH_A5, 69},
    {PITCH_B5, 71}, /* 20 */
    {PITCH_C6, 72},
    {PITCH_D6, 74},
    {PITCH_E6, 76},
    {PITCH_F6, 77},
    {PITCH_G6, 79}, /* 25 */
    {PITCH_A6, 81},
    {PITCH_B6, 83},
    {PITCH_C7, 84},
    {PITCH_D7, 86},
    {PITCH_E7, 88}, /* 30 */
    {PITCH_F7, 89},
    {PITCH_G7, 91},
    {PITCH_A7, 93},
    {PITCH_B7, 95},
    {PITCH_C8, 96}, /* 35 */
    {PITCH_D8, 98},
    {PITCH_E8, 100},
    {PITCH_F8, 101},
    {PITCH_G8, 103},
    {PITCH_A8, 105}
};

struct Pitch_table sharp_pitchs[41];

struct Pitch_table flat_pitchs[41];

struct Pitch_table double_sharp_pitchs[41];

struct Pitch_table double_flat_pitchs[41];

struct Pitch_table score_pitchs_t[41];
struct Pitch_table bar_pitchs_t[41];

struct Pitch_table score_pitchs_b[41];
struct Pitch_table bar_pitchs_b[41];


#define WHOLE             1920
#define DOTTED_WHOLE      2880
#define MINIM              960
#define DOTTED_MINIM      1440
#define CROTCHET           480
#define DOTTED_CROTCHET    720
#define QUAVER             240
#define DOTTED_QUAVER      360
#define SIXTEENTH          120
#define DOTTED_SIXTEENTH   180
#define THIRTY_SECOND       60
#define MINIM_TRIPLET      320
#define CROTCHET_TRIPLET   160


/* tie */

#define TIE_SET     (1 << 2)  /* if bit2 in attributes is on, tie is set */
#define TIE_UPPER   (1 << 3)  /* if bit3 in attributes is on, tie is upper, else tie is lower */ 

int treble_rithm;
int bass_rithm;


unsigned char mtrk_buffer[20000];
int mtrk_buffer_ix = 0;


void set_sharp_pitch_t(int pitch) {  /* destination is score pitch table */
    int i;
    int value;

    for (i=0; i<41; i++)
        if (sharp_pitchs[i].name == pitch) value = sharp_pitchs[i].value;
    for (i=0; i<41; i++)
        if (score_pitchs_t[i].name == pitch) score_pitchs_t[i].value = value;
}

void set_sharp_pitch_b(int pitch) {  /* destination is score pitch table */
    int i;
    int value;

    for (i=0; i<41; i++)
        if (sharp_pitchs[i].name == pitch) value = sharp_pitchs[i].value;
    for (i=0; i<41; i++)
        if (score_pitchs_b[i].name == pitch) score_pitchs_b[i].value = value;
}


void set_flat_pitch_t(int pitch) {  /* destination is score pitch table */
    int i;
    int value;

    for (i=0; i<41; i++)
        if (flat_pitchs[i].name == pitch) value = flat_pitchs[i].value;
    for (i=0; i<41; i++)
        if (score_pitchs_t[i].name == pitch) score_pitchs_t[i].value = value;
}

void set_flat_pitch_b(int pitch) {  /* destination is score pitch table */
    int i;
    int value;

    for (i=0; i<41; i++)
        if (flat_pitchs[i].name == pitch) value = flat_pitchs[i].value;
    for (i=0; i<41; i++)
        if (score_pitchs_b[i].name == pitch) score_pitchs_b[i].value = value;
}


/* change pitches for key scale */

void change_score_pitch_t(struct Score_element *element) {
    int i;

    for (i=0; i<41; i++) score_pitchs_t[i] = natural_pitchs[i];
    switch (element-> type) {
        case E_MAJOR :
            set_sharp_pitch_t(PITCH_D3);
            set_sharp_pitch_t(PITCH_D4);
            set_sharp_pitch_t(PITCH_D5);
            set_sharp_pitch_t(PITCH_D6);
            set_sharp_pitch_t(PITCH_D7);
            set_sharp_pitch_t(PITCH_D8);
        case A_MAJOR :
            set_sharp_pitch_t(PITCH_G3);
            set_sharp_pitch_t(PITCH_G4);
            set_sharp_pitch_t(PITCH_G5);
            set_sharp_pitch_t(PITCH_G6);
            set_sharp_pitch_t(PITCH_G7);
            set_sharp_pitch_t(PITCH_G8);
        case D_MAJOR : case B_MINOR :
            set_sharp_pitch_t(PITCH_C3);
            set_sharp_pitch_t(PITCH_C4);
            set_sharp_pitch_t(PITCH_C5);
            set_sharp_pitch_t(PITCH_C6);
            set_sharp_pitch_t(PITCH_C7);
            set_sharp_pitch_t(PITCH_C8); /* D_MAJOR  G_MAJOR ƓV[v̂ break Ȃ */
        case G_MAJOR : case E_MINOR :
            set_sharp_pitch_t(PITCH_F3);
            set_sharp_pitch_t(PITCH_F4);
            set_sharp_pitch_t(PITCH_F5);
            set_sharp_pitch_t(PITCH_F6);
            set_sharp_pitch_t(PITCH_F7);
            set_sharp_pitch_t(PITCH_F8);
            break;
        case D_FLAT_MAJOR : case B_FLAT_MINOR :
            set_flat_pitch_t(PITCH_G3);
            set_flat_pitch_t(PITCH_G4);
            set_flat_pitch_t(PITCH_G5);
            set_flat_pitch_t(PITCH_G6);
            set_flat_pitch_t(PITCH_G7); /* B_FLAT_MAJOR  F_MAJOR Ɠtbĝ break Ȃ */
            set_flat_pitch_t(PITCH_G8);
        case A_FLAT_MAJOR :
            set_flat_pitch_t(PITCH_D3);
            set_flat_pitch_t(PITCH_D4);
            set_flat_pitch_t(PITCH_D5);
            set_flat_pitch_t(PITCH_D6);
            set_flat_pitch_t(PITCH_D7);
            set_flat_pitch_t(PITCH_D8); /* B_FLAT_MAJOR  F_MAJOR Ɠtbĝ break Ȃ */
        case E_FLAT_MAJOR :
            set_flat_pitch_t(PITCH_A3);
            set_flat_pitch_t(PITCH_A4);
            set_flat_pitch_t(PITCH_A5);
            set_flat_pitch_t(PITCH_A6);
            set_flat_pitch_t(PITCH_A7); /* B_FLAT_MAJOR  F_MAJOR Ɠtbĝ break Ȃ */
            set_flat_pitch_t(PITCH_A8);
        case B_FLAT_MAJOR : case G_MINOR :
            set_flat_pitch_t(PITCH_E3);
            set_flat_pitch_t(PITCH_E4);
            set_flat_pitch_t(PITCH_E5);
            set_flat_pitch_t(PITCH_E6);
            set_flat_pitch_t(PITCH_E7);
            set_flat_pitch_t(PITCH_E8); /* B_FLAT_MAJOR  F_MAJOR Ɠtbĝ break Ȃ */
        case F_MAJOR : case D_MINOR :
            set_flat_pitch_t(PITCH_B3);
            set_flat_pitch_t(PITCH_B4);
            set_flat_pitch_t(PITCH_B5);
            set_flat_pitch_t(PITCH_B6);
            set_flat_pitch_t(PITCH_B7);
            break;
    }
}

void change_score_pitch_b(struct Score_element *element) {
    int i;

    for (i=0; i<41; i++) score_pitchs_b[i] = natural_pitchs[i];
    switch (element-> type) {
        case E_MAJOR :
            set_sharp_pitch_b(PITCH_D3);
            set_sharp_pitch_b(PITCH_D4);
            set_sharp_pitch_b(PITCH_D5);
            set_sharp_pitch_b(PITCH_D6);
            set_sharp_pitch_b(PITCH_D7);
            set_sharp_pitch_b(PITCH_D8);
        case A_MAJOR :
            set_sharp_pitch_b(PITCH_G3);
            set_sharp_pitch_b(PITCH_G4);
            set_sharp_pitch_b(PITCH_G5);
            set_sharp_pitch_b(PITCH_G6);
            set_sharp_pitch_b(PITCH_G7);
            set_sharp_pitch_b(PITCH_G8);
        case D_MAJOR : case B_MINOR :
            set_sharp_pitch_b(PITCH_C3);
            set_sharp_pitch_b(PITCH_C4);
            set_sharp_pitch_b(PITCH_C5);
            set_sharp_pitch_b(PITCH_C6);
            set_sharp_pitch_b(PITCH_C7);
            set_sharp_pitch_b(PITCH_C8); /* D_MAJOR  G_MAJOR ƓV[v̂ break Ȃ */
        case G_MAJOR : case E_MINOR :
            set_sharp_pitch_b(PITCH_F3);
            set_sharp_pitch_b(PITCH_F4);
            set_sharp_pitch_b(PITCH_F5);
            set_sharp_pitch_b(PITCH_F6);
            set_sharp_pitch_b(PITCH_F7);
            set_sharp_pitch_b(PITCH_F8);
            break;
        case D_FLAT_MAJOR : case B_FLAT_MINOR :
            set_flat_pitch_b(PITCH_G3);
            set_flat_pitch_b(PITCH_G4);
            set_flat_pitch_b(PITCH_G5);
            set_flat_pitch_b(PITCH_G6);
            set_flat_pitch_b(PITCH_G7); /* B_FLAT_MAJOR  F_MAJOR Ɠtbĝ break Ȃ */
            set_flat_pitch_b(PITCH_G8);
        case A_FLAT_MAJOR :
            set_flat_pitch_b(PITCH_D3);
            set_flat_pitch_b(PITCH_D4);
            set_flat_pitch_b(PITCH_D5);
            set_flat_pitch_b(PITCH_D6);
            set_flat_pitch_b(PITCH_D7);
            set_flat_pitch_b(PITCH_D8); /* B_FLAT_MAJOR  F_MAJOR Ɠtbĝ break Ȃ */
        case E_FLAT_MAJOR :
            set_flat_pitch_b(PITCH_A3);
            set_flat_pitch_b(PITCH_A4);
            set_flat_pitch_b(PITCH_A5);
            set_flat_pitch_b(PITCH_A6);
            set_flat_pitch_b(PITCH_A7); /* B_FLAT_MAJOR  F_MAJOR Ɠtbĝ break Ȃ */
            set_flat_pitch_b(PITCH_A8);
        case B_FLAT_MAJOR : case G_MINOR :
            set_flat_pitch_b(PITCH_E3);
            set_flat_pitch_b(PITCH_E4);
            set_flat_pitch_b(PITCH_E5);
            set_flat_pitch_b(PITCH_E6);
            set_flat_pitch_b(PITCH_E7);
            set_flat_pitch_b(PITCH_E8); /* B_FLAT_MAJOR  F_MAJOR Ɠtbĝ break Ȃ */
        case F_MAJOR : case D_MINOR :
            set_flat_pitch_b(PITCH_B3);
            set_flat_pitch_b(PITCH_B4);
            set_flat_pitch_b(PITCH_B5);
            set_flat_pitch_b(PITCH_B6);
            set_flat_pitch_b(PITCH_B7);
            break;
    }
}


/* change bar pitches for key signeture */

void change_bar_pitch_t(struct Score_element *element) {
    int i;
    int pitch;
    int value;

    /* adjust by octave */
    switch (treble_pitch) {
        case PITCH_HIGH :   pitch = element->pitch; break;
        case PITCH_MIDDLE : pitch = element->pitch - 12; break;
        case PITCH_LOW :    pitch = element->pitch - 24; break;
    }

    switch (element->type) {
        case SIG_SHARP :
            for (i=0; i<41; i++)
                if (sharp_pitchs[i].name == pitch)
                    value = sharp_pitchs[i].value;
            break;
        case SIG_FLAT :
            for (i=0; i<41; i++)
                if (flat_pitchs[i].name == pitch)
                    value = flat_pitchs[i].value;
            break;
        case SIG_NATURAL :
            for (i=0; i<41; i++)
                if (natural_pitchs[i].name == pitch)
                    value = natural_pitchs[i].value;
            break;
        case SIG_DOUBLE_SHARP :
            for (i=0; i<41; i++)
                if (double_sharp_pitchs[i].name == pitch)
                    value = double_sharp_pitchs[i].value;
            break;
        case SIG_DOUBLE_FLAT :
            for (i=0; i<41; i++)
                if (double_flat_pitchs[i].name == pitch)
                    value = double_flat_pitchs[i].value;
            break;
    }
    for (i=0; i<41; i++)
        if (bar_pitchs_t[i].name == pitch)
            bar_pitchs_t[i].value = value;

}

void change_bar_pitch_b(struct Score_element *element) {
    int i;
    int pitch;
    int value;

    /* adjust by octave */
    switch (bass_pitch) {
        case PITCH_HIGH :   pitch = element->pitch; break;
        case PITCH_MIDDLE : pitch = element->pitch - 12; break;
        case PITCH_LOW :    pitch = element->pitch - 24; break;
    }

    switch (element->type) {
        case SIG_SHARP :
            for (i=0; i<41; i++)
                if (sharp_pitchs[i].name == pitch)
                    value = sharp_pitchs[i].value;
            break;
        case SIG_FLAT :
            for (i=0; i<41; i++)
                if (flat_pitchs[i].name == pitch)
                    value = flat_pitchs[i].value;
            break;
        case SIG_NATURAL :
            for (i=0; i<41; i++)
                if (natural_pitchs[i].name == pitch)
                    value = natural_pitchs[i].value;
            break;
        case SIG_DOUBLE_SHARP :
            for (i=0; i<41; i++)
                if (double_sharp_pitchs[i].name == pitch)
                    value = double_sharp_pitchs[i].value;
            break;
        case SIG_DOUBLE_FLAT :
            for (i=0; i<41; i++)
                if (double_flat_pitchs[i].name == pitch)
                    value = double_flat_pitchs[i].value;
            break;
    }
    for (i=0; i<41; i++)
        if (bar_pitchs_b[i].name == pitch)
            bar_pitchs_b[i].value = value;
}


void init_pitch_tables() {

    int i;

    for (i=0; i<41; i++) {
        sharp_pitchs[i].name = natural_pitchs[i].name;
        sharp_pitchs[i].value = natural_pitchs[i].value + 1;
        flat_pitchs[i].name = natural_pitchs[i].name;
        flat_pitchs[i].value = natural_pitchs[i].value - 1;
        double_sharp_pitchs[i].name = natural_pitchs[i].name;
        double_sharp_pitchs[i].value = natural_pitchs[i].value + 2;
        double_flat_pitchs[i].name = natural_pitchs[i].name;
        double_flat_pitchs[i].value = natural_pitchs[i].value - 2;
    }
}


int main(int argc, char *argv[]) {

    FILE *in, *out;
    struct Score_element *element;

    unsigned int data_length;

    int tempo_in_microsec;

    int time_now;
    int last_event_time;

    /* status of treble part */
    int time_t;   /* time for next event of treble part */
    int i_t;     /* index of score_t */
    int note_t;  /* note is off(=0) or on(=1) */

    /* status of bass part */
    int time_b;  /* time for next event of bass part */
    int i_b;     /* index of score_t */
    int note_b;  /* note is off(=0) or on(=1) */

    int pitch_key;
    int last_tie_t;
    int last_tie_b;

    int i, j, k;

    int element_pitch, found;

    init_pitch_tables();

    if (argc < 3) {
        printf("usage: solfege2mid infile outfile\n");
        return;
    }

    in = fopen(argv[1], "rb");
    if (in == NULL) {
        printf(argv[1]);
        printf(" file not found\n");
        return;
    }

    for (i=0; i<128; i++) fgetc(in); /* skip headder */

    if (fgetc(in) != (char)123) {
        printf(argv[1]);
        printf(" file is not a solfege saver\n");
        return;
    }

    /* read solfege data */

    printf("reading\n");

    tempo = (int)(fgetc(in))<<8;
    tempo += (int)fgetc(in);
    treble_pitch = (int)(fgetc(in))<<8;
    treble_pitch += (int)fgetc(in);
    no_of_elements_t = (int)(fgetc(in))<<8;
    no_of_elements_t += (int)fgetc(in);

    for (i=0; i<no_of_elements_t; i++) {
        score_t[i].category = (int)(fgetc(in))<<8;
        score_t[i].category += (int)fgetc(in);
        score_t[i].type = (int)(fgetc(in))<<8;
        score_t[i].type += (int)fgetc(in);
        score_t[i].pitch = (int)(fgetc(in))<<8;
        score_t[i].pitch += (int)fgetc(in);
        score_t[i].attributes = (int)(fgetc(in))<<8;
        score_t[i].attributes += (int)fgetc(in);
    }

    bass_pitch = (int)(fgetc(in))<<8;
    bass_pitch += (int)fgetc(in);
    no_of_elements_b = (int)(fgetc(in))<<8;
    no_of_elements_b += (int)fgetc(in);

    for (i=0; i<no_of_elements_b; i++) {
        score_b[i].category = (int)(fgetc(in))<<8;
        score_b[i].category += (int)fgetc(in);
        score_b[i].type = (int)(fgetc(in))<<8;
        score_b[i].type += (int)fgetc(in);
        score_b[i].pitch = (int)(fgetc(in))<<8;
        score_b[i].pitch += (int)fgetc(in);
        score_b[i].attributes = (int)(fgetc(in))<<8;
        score_b[i].attributes += (int)fgetc(in);
    }

    fclose(in);

    /* write midi data */

    out = fopen(argv[2], "wb");

    printf("writing\n");


    /* header chunk */
    fprintf(out, "MThd");

    /* data length = 6 bytes */
    fputc(0x00, out); fputc(0x00, out); fputc(0x00, out); fputc(0x06, out);

    /* SMF format type = 0 */
    fputc(0x00, out); fputc(0x00, out);

    /* no of tracks = 1 */
    fputc(0x00, out); fputc(0x01, out);

    /* delta time = 480 = 0x01E0 */
    fputc(0x01, out); fputc(0xE0, out);

    /* track chunk 1 */
    fprintf(out, "MTrk");

    /* tempo */
    tempo_in_microsec = 60 * 10000 / tempo * 100;

    printf("tempo %d ", tempo_in_microsec);

    mtrk_buffer[mtrk_buffer_ix++] = 0x00;
    mtrk_buffer[mtrk_buffer_ix++] = 0xFF;
    mtrk_buffer[mtrk_buffer_ix++] = 0x51;
    mtrk_buffer[mtrk_buffer_ix++] = 0x03;
    mtrk_buffer[mtrk_buffer_ix++] = (unsigned char)(tempo_in_microsec>>16);
    mtrk_buffer[mtrk_buffer_ix++] = (unsigned char)(tempo_in_microsec>>8);
    mtrk_buffer[mtrk_buffer_ix++] = (unsigned char)tempo_in_microsec;

    /* init time */
    time_now = 0;
    last_event_time = time_now;

    /* status of treble part */
    time_t = 0;  /* time for next event of treble part */
    i_t = 0;     /* index of score_t */
    note_t = 0;  /* note is off(=0) or on(=1) */

    /* status of bass part */
    time_b = 0;  /* time for next event of bass part */
    i_b = 0;     /* index of score_t */
    note_b = 0;  /* note is off(=0) or on(=1) */

    for (j=0; j<41; j++) score_pitchs_t[j] = natural_pitchs[j];
    for (j=0; j<41; j++) bar_pitchs_t[j] = score_pitchs_t[j];
    for (j=0; j<41; j++) score_pitchs_b[j] = natural_pitchs[j];
    for (j=0; j<41; j++) bar_pitchs_b[j] = score_pitchs_b[j];

    while ((i_t < no_of_elements_t) || (i_b < no_of_elements_b)) {

        if ((time_t <= time_now) && (i_t < no_of_elements_t)) {

            element = &score_t[i_t];

            switch (element->category) {

                case SCORE_CREF :
                    treble_pitch = element->attributes;
                    i_t++;
                    break;

                case SCORE_RITHM :  /* set rithm for the duration of whole rest */
                    treble_rithm = element->type;
                    i_t++;
                    break;

                case SCORE_BAR :  /* bar_pitches initialization at the top of the bar */
                    for (j=0; j<41; j++) bar_pitchs_t[j] = score_pitchs_t[j];
                    i_t++;
                    break;

                case SCORE_KEY :
                    change_score_pitch_t(element);
                    for (j=0; j<41; j++) bar_pitchs_t[j] = score_pitchs_t[j];
                    i_t++;
                    break;

                case SCORE_SIG :
                    change_bar_pitch_t(element);
                    i_t++;
                    break;

                case SCORE_NOTE :
                    if (note_t == 0) {
                        /* turn note from off to on */

                        if (last_tie_t == 1) {  /* don't write anything after tie */

                            last_tie_t = 0;
                            note_t = 1;
                            time_t += element->type;

                        } else {

                            /* delta time */
                            mtrk_buffer[mtrk_buffer_ix++]
                                = (unsigned char)((((time_now - last_event_time)>>14) & 0x7f) | 0x80);
                            mtrk_buffer[mtrk_buffer_ix++]
                                = (unsigned char)((((time_now - last_event_time)>>7) & 0x7f) | 0x80);
                            mtrk_buffer[mtrk_buffer_ix++]
                                = (unsigned char)((time_now - last_event_time) & 0x7f);

                            /* note on message */
                            mtrk_buffer[mtrk_buffer_ix++] = 0x90;  /* note on, ch 0 */

                            switch (treble_pitch) {
                                case PITCH_HIGH :
                                    element_pitch = element->pitch;
                                    break;
                                case PITCH_MIDDLE :
                                    element_pitch = element->pitch - 12;
                                    break;
                                case PITCH_LOW :
                                    element_pitch = element->pitch - 24;
                                    break;
                            }
                            found = 0;
                            for (i=0; i<41; i++) {
                                if (element_pitch == bar_pitchs_t[i].name) {
                                    mtrk_buffer[mtrk_buffer_ix++] = (unsigned char)bar_pitchs_t[i].value;
                                    found = 1;
                                }
                            }

                            if (found == 0) printf ("%d value not found", i);

                            mtrk_buffer[mtrk_buffer_ix++] = 0x40;  /* velocity */
                            note_t = 1;
                            last_event_time = time_now;
                            time_t += element->type;
                        }

                        /* tie */
                        if ((element->attributes & TIE_SET) != 0)  last_tie_t = 1;  /* on */

                    } else {
                        /* note is already on */

                        if (last_tie_t == 1) {  /* don't write anything after tie */

                            note_t = 0;

                        } else {

                            /* delta time */
                            mtrk_buffer[mtrk_buffer_ix++]
                                = (unsigned char)((((time_now - last_event_time)>>14) & 0x7f) | 0x80);
                            mtrk_buffer[mtrk_buffer_ix++]
                                = (unsigned char)((((time_now - last_event_time)>>7) & 0x7f) | 0x80);
                            mtrk_buffer[mtrk_buffer_ix++]
                                = (unsigned char)((time_now - last_event_time) & 0x7f);

                            /* note off message */
                            mtrk_buffer[mtrk_buffer_ix++] = 0x80;

                            switch (treble_pitch) {
                                case PITCH_HIGH :
                                    element_pitch = element->pitch;
                                    break;
                                case PITCH_MIDDLE :
                                    element_pitch = element->pitch - 12;
                                    break;
                                case PITCH_LOW :
                                    element_pitch = element->pitch - 24;
                                    break;
                            }
                            found = 0;
                            for (i=0; i<41; i++) {
                                if (element_pitch == bar_pitchs_t[i].name) {
                                    mtrk_buffer[mtrk_buffer_ix++] = (unsigned char)bar_pitchs_t[i].value;
                                    found = 1;
                                }
                            }

                            if (found == 0) printf ("%d value not found", i);
                                            
                            mtrk_buffer[mtrk_buffer_ix++] = 0x00;  /* velocity */
                            note_t = 0;
                            last_event_time = time_now;
                        }
                        i_t++;
                    }
                    break;

                case SCORE_REST :

                    mtrk_buffer[mtrk_buffer_ix++]
                        = (unsigned char)((((time_now - last_event_time)>>14) & 0x7f) | 0x80);
                    mtrk_buffer[mtrk_buffer_ix++]
                        = (unsigned char)((((time_now - last_event_time)>>7) & 0x7f) | 0x80);
                    mtrk_buffer[mtrk_buffer_ix++]
                        = (unsigned char)((time_now - last_event_time) & 0x7f);

                    /* note on message */
                    mtrk_buffer[mtrk_buffer_ix++] = 0x80;  /* note on, ch 0 */
                    mtrk_buffer[mtrk_buffer_ix++] = 36;    /* pitch data */
                    mtrk_buffer[mtrk_buffer_ix++] = 0x00;  /* velocity = 0 */
                    note_t = 0;
                    last_event_time = time_now;
                    if (element->type == WHOLE) {
                        /* duration of Whole Rest depends on rithm */
                        switch (treble_rithm) {
                            case BINARIA      : time_t += 1920; break;  /*  2/2  */
                            case TERNARIA     : time_t += 1440; break;  /*  3/4  */
                            case QUATERNARIA  : time_t += 1920; break;  /*  4/4  */
                            case CROME        : time_t += 1440; break;  /*  6/8  */
                            case SEMICROME    : time_t += 1080; break;  /*  9/16 */
                            case TWOFOURTH    : time_t +=  960; break;  /*  2/4  */
                            case TWELVEEIGHTH : time_t += 2880; break;  /*  12/8 */
                        }
                    } else  {
                        time_t += element->type;
                    }
                    i_t++;

                    break;
            }

        } else if ((time_b <= time_now) && (i_b < no_of_elements_b)) {

            element = &score_b[i_b];

            switch (element->category) {

                case SCORE_CREF :
                    bass_pitch = element->attributes;
                    i_b++;
                    break;

                case SCORE_RITHM :  /* set rithm for the duration of whole rest */
                    bass_rithm = element->type;
                    i_b++;
                    break;

                case SCORE_BAR :  /* bar_pitches initialization at the top of the bar */
                    for (j=0; j<41; j++) bar_pitchs_b[j] = score_pitchs_b[j];
                    i_b++;
                    break;

                case SCORE_KEY :
                    change_score_pitch_b(element);
                    for (j=0; j<41; j++) bar_pitchs_b[j] = score_pitchs_b[j];
                    i_b++;
                    break;

                case SCORE_SIG :
                    change_bar_pitch_b(element);
                    i_b++;
                    break;

                case SCORE_NOTE :
                    if (note_b == 0) {
                        /* turn note from off to on */

                        if (last_tie_b == 1) {  /* don't write anything after tie */

                            last_tie_b = 0;
                            note_b = 1;
                            time_b += element->type;

                        } else {

                            /* delta time */
                            mtrk_buffer[mtrk_buffer_ix++]
                                = (unsigned char)((((time_now - last_event_time)>>14) & 0x7f) | 0x80);
                            mtrk_buffer[mtrk_buffer_ix++]
                                = (unsigned char)((((time_now - last_event_time)>>7) & 0x7f) | 0x80);
                            mtrk_buffer[mtrk_buffer_ix++]
                                = (unsigned char)((time_now - last_event_time) & 0x7f);

                            /* note on message */
                            mtrk_buffer[mtrk_buffer_ix++] = 0x91;  /* note on, ch 1 */

                            switch (bass_pitch) {
                                case PITCH_HIGH :
                                    element_pitch = element->pitch;
                                    break;
                                case PITCH_MIDDLE :
                                    element_pitch = element->pitch - 12;
                                    break;
                                case PITCH_LOW :
                                    element_pitch = element->pitch - 24;
                                    break;
                            }
                            found = 0;
                            for (i=0; i<41; i++) {
                                if (element_pitch == bar_pitchs_b[i].name) {
                                    mtrk_buffer[mtrk_buffer_ix++] = (unsigned char)bar_pitchs_b[i].value;
                                    found = 1;
                                }
                            }

                            if (found == 0) printf ("%d value not found", i);

                            mtrk_buffer[mtrk_buffer_ix++] = 0x40;  /* velocity */
                            note_b = 1;
                            last_event_time = time_now;
                            time_b += element->type;
                        }

                        /* tie */
                        if ((element->attributes & TIE_SET) != 0)  last_tie_b = 1;  /* on */

                    } else {
                        /* note is already on */

                        if (last_tie_b == 1) {  /* don't write anything after tie */

                            note_b = 0;

                        } else {

                            /* delta time */
                            mtrk_buffer[mtrk_buffer_ix++]
                                = (unsigned char)((((time_now - last_event_time)>>14) & 0x7f) | 0x80);
                            mtrk_buffer[mtrk_buffer_ix++]
                                = (unsigned char)((((time_now - last_event_time)>>7) & 0x7f) | 0x80);
                            mtrk_buffer[mtrk_buffer_ix++]
                                = (unsigned char)((time_now - last_event_time) & 0x7f);

                            /* note off message */
                            mtrk_buffer[mtrk_buffer_ix++] = 0x81;  /* note off, ch 1 */

                            switch (bass_pitch) {
                                case PITCH_HIGH :
                                    element_pitch = element->pitch;
                                    break;
                                case PITCH_MIDDLE :
                                    element_pitch = element->pitch - 12;
                                    break;
                                case PITCH_LOW :
                                    element_pitch = element->pitch - 24;
                                    break;
                            }
                            found = 0;
                            for (i=0; i<41; i++) {
                                if (element_pitch == bar_pitchs_b[i].name) {
                                    mtrk_buffer[mtrk_buffer_ix++] = (unsigned char)bar_pitchs_b[i].value;
                                    found = 1;
                                }
                            }

                            if (found == 0) printf ("%d value not found", i);

                            mtrk_buffer[mtrk_buffer_ix++] = 0x00;  /* velocity */
                            note_b = 0;
                            last_event_time = time_now;
                        }
                        i_b++;
                    }
                    break;

                case SCORE_REST :

                    mtrk_buffer[mtrk_buffer_ix++]
                        = (unsigned char)((((time_now - last_event_time)>>14) & 0x7f) | 0x80);
                    mtrk_buffer[mtrk_buffer_ix++]
                        = (unsigned char)((((time_now - last_event_time)>>7) & 0x7f) | 0x80);
                    mtrk_buffer[mtrk_buffer_ix++]
                        = (unsigned char)((time_now - last_event_time) & 0x7f);

                    /* note on message */
                    mtrk_buffer[mtrk_buffer_ix++] = 0x81;  /* note off, ch 1 */
                    mtrk_buffer[mtrk_buffer_ix++] = 36;    /* pitch data */
                    mtrk_buffer[mtrk_buffer_ix++] = 0x00;  /* velocity = 0 */
                    note_b = 0;
                    last_event_time = time_now;
                    if (element->type == WHOLE) {
                        /* duration of Whole Rest depends on rithm */
                        switch (bass_rithm) {
                            case BINARIA      : time_b += 1920; break;  /*  2/2  */
                            case TERNARIA     : time_b += 1440; break;  /*  3/4  */
                            case QUATERNARIA  : time_b += 1920; break;  /*  4/4  */
                            case CROME        : time_b += 1440; break;  /*  6/8  */
                            case SEMICROME    : time_b += 1080; break;  /*  9/16 */
                            case TWOFOURTH    : time_b +=  960; break;  /*  2/4  */
                            case TWELVEEIGHTH : time_b += 2880; break;  /*  12/8 */
                        }
                    } else  {
                        time_b += element->type;
                    }
                    i_b++;

                    break;
                }
        } else {

            time_now++;
        }
    }

    /* end of track */
    mtrk_buffer[mtrk_buffer_ix++] = 0x01;
    mtrk_buffer[mtrk_buffer_ix++] = 0xFF;
    mtrk_buffer[mtrk_buffer_ix++] = 0x2F;
    mtrk_buffer[mtrk_buffer_ix++] = 0x00;

    /* data length calcuration */
    fputc((unsigned char)(mtrk_buffer_ix>>24), out);
    fputc((unsigned char)(mtrk_buffer_ix>>16), out);
    fputc((unsigned char)(mtrk_buffer_ix>>8), out);
    fputc((unsigned char)mtrk_buffer_ix, out);

    printf("data length %d", mtrk_buffer_ix);
    printf("\n");

    fwrite(mtrk_buffer, 1, mtrk_buffer_ix, out);

    fclose(out);
}
