#include <stdio.h>


/* score element class */

#define SCORE_CREF   1
#define SCORE_KEY    2
#define SCORE_RITHM  3
#define SCORE_NOTE   4
#define SCORE_REST   5
#define SCORE_SIG    6    /* key signiture */
#define SCORE_BAR    7    /* bar section mark */


/* rithm */

#define BINARIA      2    /*  2/2  */
#define TERNARIA     3	  /*  3/4  */
#define QUATERNARIA  4	  /*  4/4  */
#define CROME        6	  /*  6/8  */
#define SEMICROME    9	  /*  9/16 */
#define TWOFOURTH    24   /*  2/4  */
#define TWELVEEIGHTH 128  /*  12/8 */


/* keys */

#define C_MAJOR 1
#define D_MAJOR 2
#define E_MAJOR 3
#define F_MAJOR 4
#define G_MAJOR 5
#define A_MAJOR 6
#define B_MAJOR 7
#define A_MINOR 8
#define B_MINOR 9
#define C_MINOR 10
#define D_MINOR 11
#define E_MINOR 12
#define F_MINOR 13
#define G_MINOR 14
#define A_FLAT_MAJOR 15
#define B_FLAT_MAJOR 16
#define C_FLAT_MAJOR 17
#define D_FLAT_MAJOR 18
#define E_FLAT_MAJOR 19
#define B_FLAT_MINOR 20


/* key signituras */

#define SIG_SHARP        1
#define SIG_FLAT         2
#define SIG_NATURAL      3
#define SIG_DOUBLE_SHARP 4
#define SIG_DOUBLE_FLAT  5


int tempo;
int treble_pitch;
int no_of_elements_t;
int bass_pitch;
int no_of_elements_b;

struct Score_element {
    int category;
    int type;
    int pitch;
    int attributes;
    int position;
};

#define SCORE_SIZE 800

struct Score_element score_t[SCORE_SIZE];
int no_of_elements_t;
int score_end_position_t;

struct Score_element score_b[SCORE_SIZE];
int no_of_elements_b;
int score_end_position_b;


/* pitch */

#define PITCH_NONE  0
#define PITCH_C3   36
#define PITCH_D3   38
#define PITCH_E3   40
#define PITCH_F3   41
#define PITCH_G3   43
#define PITCH_A3   45
#define PITCH_B3   47
#define PITCH_C4   48
#define PITCH_D4   50
#define PITCH_E4   52
#define PITCH_F4   53
#define PITCH_G4   55
#define PITCH_A4   57
#define PITCH_B4   59
#define PITCH_C5   60
#define PITCH_D5   62
#define PITCH_E5   64
#define PITCH_F5   65
#define PITCH_G5   67
#define PITCH_A5   69
#define PITCH_B5   71
#define PITCH_C6   72
#define PITCH_D6   74
#define PITCH_E6   76
#define PITCH_F6   77
#define PITCH_G6   79
#define PITCH_A6   81
#define PITCH_B6   83
#define PITCH_C7   84
#define PITCH_D7   86
#define PITCH_E7   88
#define PITCH_F7   89
#define PITCH_G7   91
#define PITCH_A7   93
#define PITCH_B7   95
#define PITCH_C8   96
#define PITCH_D8   98
#define PITCH_E8  100
#define PITCH_F8  101
#define PITCH_G8  103
#define PITCH_A8  105


/* pitch by octave */

#define PITCH_HIGH   1
#define PITCH_MIDDLE 2
#define PITCH_LOW    3


struct Pitch_table {
    int name;
    int octave;
    char pitch[5];
};

const struct Pitch_table natural_pitchs[41] = {
    {PITCH_C3, 3, "c"}, /*  0 */
    {PITCH_D3, 3, "d"},
    {PITCH_E3, 3, "e"},
    {PITCH_F3, 3, "f"},
    {PITCH_G3, 3, "g"},
    {PITCH_A3, 3, "a"}, /*  5 */
    {PITCH_B3, 3, "b"},
    {PITCH_C4, 4, "c"},
    {PITCH_D4, 4, "d"},
    {PITCH_E4, 4, "e"},
    {PITCH_F4, 4, "f"}, /* 10 */
    {PITCH_G4, 4, "g"},
    {PITCH_A4, 4, "a"},
    {PITCH_B4, 4, "b"},
    {PITCH_C5, 5, "c"},
    {PITCH_D5, 5, "d"}, /* 15 */
    {PITCH_E5, 5, "e"},
    {PITCH_F5, 5, "f"},
    {PITCH_G5, 5, "g"},
    {PITCH_A5, 5, "a"},
    {PITCH_B5, 5, "b"}, /* 20 */
    {PITCH_C6, 6, "c"},
    {PITCH_D6, 6, "d"},
    {PITCH_E6, 6, "e"},
    {PITCH_F6, 6, "f"},
    {PITCH_G6, 6, "g"}, /* 25 */
    {PITCH_A6, 6, "a"},
    {PITCH_B6, 6, "b"},
    {PITCH_C7, 7, "c"},
    {PITCH_D7, 7, "d"},
    {PITCH_E7, 7, "e"}, /* 30 */
    {PITCH_F7, 7 ,"f"},
    {PITCH_G7, 7, "g"},
    {PITCH_A7, 7, "a"},
    {PITCH_B7, 7, "b"},
    {PITCH_C8, 8, "c"}, /* 35 */
    {PITCH_D8, 8, "d"},
    {PITCH_E8, 8, "e"},
    {PITCH_F8, 8, "f"},
    {PITCH_G8, 8, "g"},
    {PITCH_A8, 8, "a"}
};

const struct Pitch_table sharp_pitchs[41] = {
    {PITCH_C3, 3, "c+"}, /*  0 */
    {PITCH_D3, 3, "d+"},
    {PITCH_E3, 3, "f"},
    {PITCH_F3, 3, "f+"},
    {PITCH_G3, 3, "g+"},
    {PITCH_A3, 3, "a+"}, /*  5 */
    {PITCH_B3, 4, "c"},
    {PITCH_C4, 4, "c+"},
    {PITCH_D4, 4, "d+"},
    {PITCH_E4, 4, "f"},
    {PITCH_F4, 4, "f+"}, /* 10 */
    {PITCH_G4, 4, "g+"},
    {PITCH_A4, 4, "a+"},
    {PITCH_B4, 5, "c"},
    {PITCH_C5, 5, "c+"},
    {PITCH_D5, 5, "d+"}, /* 15 */
    {PITCH_E5, 5, "f"},
    {PITCH_F5, 5, "f+"},
    {PITCH_G5, 5, "g+"},
    {PITCH_A5, 5, "a+"},
    {PITCH_B5, 5, "c"}, /* 20 */
    {PITCH_C6, 6, "c+"},
    {PITCH_D6, 6, "d+"},
    {PITCH_E6, 6, "f"},
    {PITCH_F6, 6, "f+"},
    {PITCH_G6, 6, "g+"}, /* 25 */
    {PITCH_A6, 6, "a+"},
    {PITCH_B6, 7, "c"},
    {PITCH_C7, 7, "c+"},
    {PITCH_D7, 7, "d+"},
    {PITCH_E7, 7, "f"}, /* 30 */
    {PITCH_F7, 7 ,"f+"},
    {PITCH_G7, 7, "g+"},
    {PITCH_A7, 7, "a+"},
    {PITCH_B7, 8, "c"},
    {PITCH_C8, 8, "c+"}, /* 35 */
    {PITCH_D8, 8, "d+"},
    {PITCH_E8, 8, "f"},
    {PITCH_F8, 8, "f+"},
    {PITCH_G8, 8, "g+"},
    {PITCH_A8, 8, "a+"}
};

const struct Pitch_table flat_pitchs[41] = {
    {PITCH_C3, 2, "b"}, /*  0 */
    {PITCH_D3, 3, "d-"},
    {PITCH_E3, 3, "e-"},
    {PITCH_F3, 3, "e"},
    {PITCH_G3, 3, "g-"},
    {PITCH_A3, 3, "a-"}, /*  5 */
    {PITCH_B3, 3, "b-"},
    {PITCH_C4, 3, "b"},
    {PITCH_D4, 4, "d-"},
    {PITCH_E4, 4, "e-"},
    {PITCH_F4, 4, "e"}, /* 10 */
    {PITCH_G4, 4, "g-"},
    {PITCH_A4, 4, "a-"},
    {PITCH_B4, 4, "b-"},
    {PITCH_C5, 4, "b"},
    {PITCH_D5, 5, "d-"}, /* 15 */
    {PITCH_E5, 5, "e-"},
    {PITCH_F5, 5, "e"},
    {PITCH_G5, 5, "g-"},
    {PITCH_A5, 5, "a-"},
    {PITCH_B5, 5, "b-"}, /* 20 */
    {PITCH_C6, 5, "b"},
    {PITCH_D6, 6, "d-"},
    {PITCH_E6, 6, "e-"},
    {PITCH_F6, 6, "e"},
    {PITCH_G6, 6, "g-"}, /* 25 */
    {PITCH_A6, 6, "a-"},
    {PITCH_B6, 6, "b-"},
    {PITCH_C7, 6, "b"},
    {PITCH_D7, 7, "d-"},
    {PITCH_E7, 7, "e-"}, /* 30 */
    {PITCH_F7, 7 ,"e"},
    {PITCH_G7, 7, "g-"},
    {PITCH_A7, 7, "a-"},
    {PITCH_B7, 7, "b-"},
    {PITCH_C8, 7, "b"}, /* 35 */
    {PITCH_D8, 8, "d-"},
    {PITCH_E8, 8, "e-"},
    {PITCH_F8, 8, "e"},
    {PITCH_G8, 8, "g-"},
    {PITCH_A8, 8, "a-"}
};

const struct Pitch_table double_sharp_pitchs[41] = {
    {PITCH_C3, 3, "d"}, /*  0 */
    {PITCH_D3, 3, "e"},
    {PITCH_E3, 3, "f+"},
    {PITCH_F3, 3, "g"},
    {PITCH_G3, 3, "a"},
    {PITCH_A3, 3, "b"}, /*  5 */
    {PITCH_B3, 4, "c+"},
    {PITCH_C4, 4, "d"},
    {PITCH_D4, 4, "e"},
    {PITCH_E4, 4, "f+"},
    {PITCH_F4, 4, "g"}, /* 10 */
    {PITCH_G4, 4, "a"},
    {PITCH_A4, 4, "b"},
    {PITCH_B4, 5, "c+"},
    {PITCH_C5, 5, "d"},
    {PITCH_D5, 5, "e"}, /* 15 */
    {PITCH_E5, 5, "f+"},
    {PITCH_F5, 5, "g"},
    {PITCH_G5, 5, "a"},
    {PITCH_A5, 5, "b"},
    {PITCH_B5, 5, "c+"}, /* 20 */
    {PITCH_C6, 6, "d"},
    {PITCH_D6, 6, "e"},
    {PITCH_E6, 6, "f+"},
    {PITCH_F6, 6, "g"},
    {PITCH_G6, 6, "a"}, /* 25 */
    {PITCH_A6, 6, "b"},
    {PITCH_B6, 7, "c+"},
    {PITCH_C7, 7, "d"},
    {PITCH_D7, 7, "e"},
    {PITCH_E7, 7, "f+"}, /* 30 */
    {PITCH_F7, 7 ,"g"},
    {PITCH_G7, 7, "a"},
    {PITCH_A7, 7, "b"},
    {PITCH_B7, 8, "c+"},
    {PITCH_C8, 8, "d"}, /* 35 */
    {PITCH_D8, 8, "e"},
    {PITCH_E8, 8, "f+"},
    {PITCH_F8, 8, "f"},
    {PITCH_G8, 8, "a"},
    {PITCH_A8, 8, "b"}
};

const struct Pitch_table double_flat_pitchs[41] = {
    {PITCH_C3, 2, "b-"}, /*  0 */
    {PITCH_D3, 3, "c"},
    {PITCH_E3, 3, "d"},
    {PITCH_F3, 3, "e-"},
    {PITCH_G3, 3, "f"},
    {PITCH_A3, 3, "g"}, /*  5 */
    {PITCH_B3, 3, "a"},
    {PITCH_C4, 3, "b-"},
    {PITCH_D4, 4, "c"},
    {PITCH_E4, 4, "d"},
    {PITCH_F4, 4, "e-"}, /* 10 */
    {PITCH_G4, 4, "f"},
    {PITCH_A4, 4, "g"},
    {PITCH_B4, 4, "a"},
    {PITCH_C5, 4, "b-"},
    {PITCH_D5, 5, "c"}, /* 15 */
    {PITCH_E5, 5, "d"},
    {PITCH_F5, 5, "e-"},
    {PITCH_G5, 5, "f"},
    {PITCH_A5, 5, "g"},
    {PITCH_B5, 5, "a"}, /* 20 */
    {PITCH_C6, 5, "b-"},
    {PITCH_D6, 6, "c"},
    {PITCH_E6, 6, "d"},
    {PITCH_F6, 6, "e-"},
    {PITCH_G6, 6, "f"}, /* 25 */
    {PITCH_A6, 6, "g"},
    {PITCH_B6, 6, "a"},
    {PITCH_C7, 6, "b-"},
    {PITCH_D7, 7, "c"},
    {PITCH_E7, 7, "d"}, /* 30 */
    {PITCH_F7, 7 ,"e-"},
    {PITCH_G7, 7, "f"},
    {PITCH_A7, 7, "f"},
    {PITCH_B7, 7, "a"},
    {PITCH_C8, 7, "b-"}, /* 35 */
    {PITCH_D8, 8, "c"},
    {PITCH_E8, 8, "d"},
    {PITCH_F8, 8, "e-"},
    {PITCH_G8, 8, "f"},
    {PITCH_A8, 8, "g"}
};

struct Pitch_table score_pitchs[41];

struct Pitch_table bar_pitchs[41];


#define WHOLE             1920
#define DOTTED_WHOLE      2880
#define MINIM              960
#define DOTTED_MINIM      1440
#define CROTCHET           480
#define DOTTED_CROTCHET    720
#define QUAVER             240
#define DOTTED_QUAVER      360
#define SIXTEENTH          120
#define DOTTED_SIXTEENTH   180
#define THIRTY_SECOND       60
#define MINIM_TRIPLET      320
#define CROTCHET_TRIPLET   160


struct Duration_table {
    int name;
    char duration[5];
};

struct Duration_table duration_table[13] = {
    {WHOLE,            "1"  },
    {DOTTED_WHOLE,     "1." },
    {MINIM,            "2"  },
    {DOTTED_MINIM,     "2." },
    {CROTCHET,         "4"  },
    {DOTTED_CROTCHET,  "4." },
    {QUAVER,           "8"  },
    {DOTTED_QUAVER,    "8." },
    {SIXTEENTH,        "16" },
    {DOTTED_SIXTEENTH, "16."},
    {THIRTY_SECOND,    "32"  },
    {MINIM_TRIPLET,    "6"  },
    {CROTCHET_TRIPLET, "12" }
};

struct Duration_table rithm_durations[7] = {
    {BINARIA,      "1"    },
    {TERNARIA,     "2."   },
    {QUATERNARIA,  "1"    },
    {CROME,        "2."   },
    {SEMICROME,    "2r16" },
    {TWOFOURTH,    "2"    },
    {TWELVEEIGHTH, "1."   }
};


/* tie */

#define TIE_SET     (1 << 2)  /* if bit2 in attributes is on, tie is set */
#define TIE_UPPER   (1 << 3)  /* if bit3 in attributes is on, tie is upper, else tie is lower */ 


int pitch;

int rithm;


void set_sharp_pitch(int pitch) {  /* destination is score pitch table */
    int i, j;
    int octave;
    char pitch_string[5];

    for (i=0; i<41; i++)
        if (sharp_pitchs[i].name == pitch) {
            octave = sharp_pitchs[i].octave;
            for (j=0; j<5; j++) pitch_string[j] = (sharp_pitchs[i].pitch)[j];
        }
            
    for (i=0; i<41; i++)
        if (score_pitchs[i].name == pitch) {
            score_pitchs[i].octave = octave;
            for (j=0; j<5; j++) (score_pitchs[i].pitch)[j] = pitch_string[j];
        }
}


void set_flat_pitch(int pitch) {  /* destination is score pitch table */
    int i, j;
    int octave;
    char pitch_string[5];

    for (i=0; i<41; i++)
        if (flat_pitchs[i].name == pitch) {
            octave = flat_pitchs[i].octave;
            for (j=0; j<5; j++) pitch_string[j] = (flat_pitchs[i].pitch)[j];
        }
            
    for (i=0; i<41; i++)
        if (score_pitchs[i].name == pitch) {
            score_pitchs[i].octave = octave;
            for (j=0; j<5; j++) (score_pitchs[i].pitch)[j] = pitch_string[j];
        }
}


void change_score_pitch(struct Score_element *element) {
    int i;

    for (i=0; i<41; i++) score_pitchs[i] = natural_pitchs[i];
    switch (element-> type) {
        case E_MAJOR :
            set_sharp_pitch(PITCH_D3);
            set_sharp_pitch(PITCH_D4);
            set_sharp_pitch(PITCH_D5);
            set_sharp_pitch(PITCH_D6);
            set_sharp_pitch(PITCH_D7);
            set_sharp_pitch(PITCH_D8);
        case A_MAJOR :
            set_sharp_pitch(PITCH_G3);
            set_sharp_pitch(PITCH_G4);
            set_sharp_pitch(PITCH_G5);
            set_sharp_pitch(PITCH_G6);
            set_sharp_pitch(PITCH_G7);
            set_sharp_pitch(PITCH_G8);
        case D_MAJOR : case B_MINOR :
            set_sharp_pitch(PITCH_C3);
            set_sharp_pitch(PITCH_C4);
            set_sharp_pitch(PITCH_C5);
            set_sharp_pitch(PITCH_C6);
            set_sharp_pitch(PITCH_C7);
            set_sharp_pitch(PITCH_C8); /* D_MAJOR  G_MAJOR ƓV[v̂ break Ȃ */
        case G_MAJOR : case E_MINOR :
            set_sharp_pitch(PITCH_F3);
            set_sharp_pitch(PITCH_F4);
            set_sharp_pitch(PITCH_F5);
            set_sharp_pitch(PITCH_F6);
            set_sharp_pitch(PITCH_F7);
            set_sharp_pitch(PITCH_F8);
            break;
        case D_FLAT_MAJOR : case B_FLAT_MINOR :
            set_flat_pitch(PITCH_G3);
            set_flat_pitch(PITCH_G4);
            set_flat_pitch(PITCH_G5);
            set_flat_pitch(PITCH_G6);
            set_flat_pitch(PITCH_G7); /* B_FLAT_MAJOR  F_MAJOR Ɠtbĝ break Ȃ */
            set_flat_pitch(PITCH_G8);
        case A_FLAT_MAJOR :
            set_flat_pitch(PITCH_D3);
            set_flat_pitch(PITCH_D4);
            set_flat_pitch(PITCH_D5);
            set_flat_pitch(PITCH_D6);
            set_flat_pitch(PITCH_D7);
            set_flat_pitch(PITCH_D8); /* B_FLAT_MAJOR  F_MAJOR Ɠtbĝ break Ȃ */
        case E_FLAT_MAJOR :
            set_flat_pitch(PITCH_A3);
            set_flat_pitch(PITCH_A4);
            set_flat_pitch(PITCH_A5);
            set_flat_pitch(PITCH_A6);
            set_flat_pitch(PITCH_A7); /* B_FLAT_MAJOR  F_MAJOR Ɠtbĝ break Ȃ */
            set_flat_pitch(PITCH_A8);
        case B_FLAT_MAJOR : case G_MINOR :
            set_flat_pitch(PITCH_E3);
            set_flat_pitch(PITCH_E4);
            set_flat_pitch(PITCH_E5);
            set_flat_pitch(PITCH_E6);
            set_flat_pitch(PITCH_E7);
            set_flat_pitch(PITCH_E8); /* B_FLAT_MAJOR  F_MAJOR Ɠtbĝ break Ȃ */
        case F_MAJOR : case D_MINOR :
            set_flat_pitch(PITCH_B3);
            set_flat_pitch(PITCH_B4);
            set_flat_pitch(PITCH_B5);
            set_flat_pitch(PITCH_B6);
            set_flat_pitch(PITCH_B7);
            break;
    }
}


void change_bar_pitch(struct Score_element *element) {
    int i, j;
    int pitch_string[5];

    int rithm;  /* may be used to calc duratino of whole rest */

    int pitch_key;  /* PITCH_B3 or so, adjusted by crefs pitch */
    int octave;

    /* adjust by octave */
    switch (pitch) {
        case PITCH_HIGH :   pitch_key = element->pitch; break;
        case PITCH_MIDDLE : pitch_key = element->pitch - 12; break;
        case PITCH_LOW :    pitch_key = element->pitch - 24; break;
    }

    switch (element->type) {
        case SIG_SHARP :
            for (i=0; i<41; i++)
                if (sharp_pitchs[i].name == pitch_key) {
                    octave = sharp_pitchs[i].octave;
                    for (j=0; j<5; j++) pitch_string[j] = (sharp_pitchs[i].pitch)[j];
                }
            break;
        case SIG_FLAT :
            for (i=0; i<41; i++)
                if (flat_pitchs[i].name == pitch_key) {
                    octave = flat_pitchs[i].octave;
                    for (j=0; j<5; j++) pitch_string[j] = (flat_pitchs[i].pitch)[j];
                }
            break;
        case SIG_NATURAL :
            for (i=0; i<41; i++)
                if (natural_pitchs[i].name == pitch_key) {
                    octave = natural_pitchs[i].octave;
                    for (j=0; j<5; j++) pitch_string[j] = (natural_pitchs[i].pitch)[j];
                }
            break;
        case SIG_DOUBLE_SHARP :
            for (i=0; i<41; i++)
                if (double_sharp_pitchs[i].name == pitch_key) {
                    octave = double_sharp_pitchs[i].octave;
                    for (j=0; j<5; j++) pitch_string[j] = (double_sharp_pitchs[i].pitch)[j];
                }
            break;
        case SIG_DOUBLE_FLAT :
            for (i=0; i<41; i++)
                if (double_flat_pitchs[i].name == pitch_key) {
                    octave = double_flat_pitchs[i].octave;
                    for (j=0; j<5; j++) pitch_string[j] = (double_flat_pitchs[i].pitch)[j];
                }
            break;
    }
    for (i=0; i<41; i++)
        if (bar_pitchs[i].name == pitch_key) {
            bar_pitchs[i].octave = octave;
            for (j=0; j<5; j++) (bar_pitchs[i].pitch)[j] = pitch_string[j];
        }
}


main(int argc, char *argv[]) {

    FILE *in, *out;
    struct Score_element *element;
    char duration_string[5];
    char pitch_string[5];
    int pitch_key;  /* PITCH_B3 or so, adjusted by crefs pitch */
    int current_octave, new_octave;
    int tie_set = 0;

    int i, j, k;

    if (argc < 3) {
        printf("usage: solfege2mml infile outfile\n");
        return;
    }

    in = fopen(argv[1], "rb");
    if (in == NULL) {
        printf(argv[1]);
        printf(" file not found\n");
        return;
    }

    for (i=0; i<128; i++) fgetc(in); /* skip headder */

    if (fgetc(in) != (char)123) {
        printf(argv[1]);
        printf(" file is not a solfege saver\n");
        return;
    }

    /* read solfege data */

    printf("reading\n");

    tempo = (int)(fgetc(in))<<8;
    tempo += (int)fgetc(in);
    treble_pitch = (int)(fgetc(in))<<8;
    treble_pitch += (int)fgetc(in);
    no_of_elements_t = (int)(fgetc(in))<<8;
    no_of_elements_t += (int)fgetc(in);

    for (i=0; i<no_of_elements_t; i++) {
        score_t[i].category = (int)(fgetc(in))<<8;
        score_t[i].category += (int)fgetc(in);
        score_t[i].type = (int)(fgetc(in))<<8;
        score_t[i].type += (int)fgetc(in);
        score_t[i].pitch = (int)(fgetc(in))<<8;
        score_t[i].pitch += (int)fgetc(in);
        score_t[i].attributes = (int)(fgetc(in))<<8;
        score_t[i].attributes += (int)fgetc(in);
    }

    bass_pitch = (int)(fgetc(in))<<8;
    bass_pitch += (int)fgetc(in);
    no_of_elements_b = (int)(fgetc(in))<<8;
    no_of_elements_b += (int)fgetc(in);

    for (i=0; i<no_of_elements_b; i++) {
        score_b[i].category = (int)(fgetc(in))<<8;
        score_b[i].category += (int)fgetc(in);
        score_b[i].type = (int)(fgetc(in))<<8;
        score_b[i].type += (int)fgetc(in);
        score_b[i].pitch = (int)(fgetc(in))<<8;
        score_b[i].pitch += (int)fgetc(in);
        score_b[i].attributes = (int)(fgetc(in))<<8;
        score_b[i].attributes += (int)fgetc(in);
    }

    fclose(in);

    /* write mml data */

    out = fopen(argv[2], "w");

    printf("writing\n");

    fprintf(out, ";MML\n");

    /* tempo */
    fputc('t', out);
    fprintf(out, "%d", tempo);
    fputc('\n', out);

    /* treble */

    tie_set = 0;
    fprintf(out, "#0@3v12o4\n");
    current_octave = 4;

    for (i=0; i<41; i++) score_pitchs[i] = natural_pitchs[i];
    for (i=0; i<41; i++) bar_pitchs[i] = score_pitchs[i];

    for (i=0; i<no_of_elements_t; i++) {

        element = &score_t[i];

        switch (element->category) {

            case SCORE_CREF :
                pitch = element->attributes;
                break;

            case SCORE_RITHM :  /* set rithm for the duration of whole rest */
                rithm = element->type;
                for (j=0; j<7; j++) {
                     if (rithm_durations[j].name == rithm)
                         for (k=0; k<5; k++) duration_string[k] = rithm_durations[j].duration[k];
                }
                for (j=0; j<13; j++) {
                     if (duration_table[j].name == WHOLE)
                         for (k=0; k<5; k++) duration_table[j].duration[k] = duration_string[k];
                }
                break;

            case SCORE_BAR :  /* bar_pitches initialization at the top of the bar */
                for (j=0; j<41; j++) bar_pitchs[j] = score_pitchs[j];
                if (tie_set == 0) fputc('\n', out);
                break;

            case SCORE_KEY :
                change_score_pitch(element);
                for (j=0; j<41; j++) bar_pitchs[j] = score_pitchs[j];
                break;

            case SCORE_SIG :
                change_bar_pitch(element);
                break;

            case SCORE_NOTE :
                switch (tie_set) {
                    case 0 : /* tie (of last note) is not set eq. normal */
                        for (j=0; j<41; j++) {

                            /* adjust by octave */
                            switch (pitch) {
                                case PITCH_HIGH :   pitch_key = element->pitch; break;
                                case PITCH_MIDDLE : pitch_key = element->pitch - 12; break;
                                case PITCH_LOW :    pitch_key = element->pitch - 24; break;
                            }

                            if (pitch_key == bar_pitchs[j].name) {
                                new_octave = bar_pitchs[j].octave;
                                for (k=0; k<5; k++) pitch_string[k] = (bar_pitchs[j].pitch)[k];
                            }
                        }
                        if (current_octave != new_octave) {  /* octave is changed */
                            current_octave = new_octave;
                            fprintf(out, "o");
                            fprintf(out, "%d", current_octave-1);
                        }
                        fprintf(out, pitch_string);
                        break;
                    case 1 : /* tie (of last note) is set, pitch is ommited */
                        fputc('^', out);
                        break;
                    default : /* 2nd tie is not treat by SOUNDIL, ad-hoc treatment */ 
                        fputc('r', out);
                        break;
                }

                /* write duration */
                for (j=0; j<13; j++) {
                    if (element->type == duration_table[j].name) {
                        for (k=0; k<5; k++) duration_string[k] = (duration_table[j].duration)[k];
                    }
                }
                fprintf(out, duration_string);

                /* tie */
                if ((element->attributes & TIE_SET) != 0) {
                    tie_set += 1;
                } else {
                    tie_set = 0;
                }
                break;

            case SCORE_REST :

                /* write rest */
                fputc('r', out);

                /* write duration */
                for (j=0; j<13; j++) {
                    if (element->type == duration_table[j].name) {
                        for (k=0; k<5; k++) duration_string[k] = duration_table[j].duration[k];
                    }
                }
                fprintf(out, duration_string);

                /* tie */
                tie_set = 0;

                break;
        }
    }
    fputc('\n', out);

    /* bass */

    tie_set = 0;
    fprintf(out, "#1@3v12o4\n");
    current_octave = 4;

    for (i=0; i<41; i++) score_pitchs[i] = natural_pitchs[i];
    for (i=0; i<41; i++) bar_pitchs[i] = score_pitchs[i];

    for (i=0; i<no_of_elements_b; i++) {

        element = &score_b[i];

        switch (element->category) {

            case SCORE_CREF :
                pitch = element->attributes;
                break;

            case SCORE_RITHM :  /* set rithm for the duration of whole rest */
                rithm = element->type;
                for (j=0; j<7; j++) {
                     if (rithm_durations[j].name == rithm)
                         for (k=0; k<5; k++) duration_string[k] = rithm_durations[j].duration[k];
                }
                for (j=0; j<13; j++) {
                     if (duration_table[j].name == WHOLE)
                         for (k=0; k<5; k++) duration_table[j].duration[k] = duration_string[k];
                }
                break;

            case SCORE_BAR :  /* bar_pitches initialization at the top of the bar */
                for (j=0; j<41; j++) bar_pitchs[j] = score_pitchs[j];
                if (tie_set == 0) fputc('\n', out);
                break;

            case SCORE_KEY :
                change_score_pitch(element);
                for (j=0; j<41; j++) bar_pitchs[j] = score_pitchs[j];
                break;

            case SCORE_SIG :
                change_bar_pitch(element);
                break;

            case SCORE_NOTE :
                switch (tie_set) {
                    case 0 : /* tie (of last note) is not set eq. normal */
                        for (j=0; j<41; j++) {

                            /* adjust by octave */
                            switch (pitch) {
                                case PITCH_HIGH :   pitch_key = element->pitch; break;
                                case PITCH_MIDDLE : pitch_key = element->pitch - 12; break;
                                case PITCH_LOW :    pitch_key = element->pitch - 24; break;
                            }

                            if (pitch_key == bar_pitchs[j].name) {
                                new_octave = bar_pitchs[j].octave;
                                for (k=0; k<5; k++) pitch_string[k] = (bar_pitchs[j].pitch)[k];
                            }
                        }
                        if (current_octave != new_octave) {  /* octave is changed */
                            current_octave = new_octave;
                            fprintf(out, "o");
                            fprintf(out, "%d", current_octave-1);
                        }
                        fprintf(out, pitch_string);
                        break;
                    case 1 : /* tie (of last note) is set, pitch is ommited */
                        fputc('^', out);
                        break;
                    default : /* 2nd tie is not treat by SOUNDIL, ad-hoc treatment */ 
                        fputc('r', out);
                        break;
                }

                /* write duration */
                for (j=0; j<13; j++) {
                    if (element->type == duration_table[j].name) {
                        for (k=0; k<5; k++) duration_string[k] = (duration_table[j].duration)[k];
                    }
                }
                fprintf(out, duration_string);

                /* tie */
                if ((element->attributes & TIE_SET) != 0) {
                    tie_set += 1;
                } else {
                    tie_set = 0;
                }
                break;

            case SCORE_REST :

                /* write rest */
                fputc('r', out);

                /* write duration */
                for (j=0; j<13; j++) {
                    if (element->type == duration_table[j].name) {
                        for (k=0; k<5; k++) duration_string[k] = duration_table[j].duration[k];
                    }
                }
                fprintf(out, duration_string);

                /* tie */
                tie_set = 0;

                break;
        }
    }
    fputc('\n', out);

    fclose(out);
}
